//
//  ViewController.swift
//  AlamofireSample
//
//  Created by oga on 2015/09/06.
//  Copyright © 2015年 R.O Works. All rights reserved.
//

import UIKit
import Alamofire

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        code_8_get()
        code_8_response()
        code_8_post()
        code_8_fileupload()
        code_8_filedownload()
    }

    /**
    GETの例
    */
    func code_8_get() {
        let url = "http://httpbin.org/get"
        Alamofire.request(.GET, url, parameters: ["dog" : "Frenchbulldog"])
        .response { (request, response, data, error) in
            print(data)
        }
    }
    /**
    response で受信したデータ処理
    */
    func code_8_response() {
        let url = "http://httpbin.org/get"
        Alamofire.request(.GET, url, parameters: ["computer" : "iMac"])
        .responseString { response in // （1）
            switch response.result {
            case .Success(let dataString):
                print(dataString)
            case .Failure(let error):
                print(error)
            }
            
        }
        .responseJSON { response in // （2）
            switch response.result {
            case .Success(let json):
                print(json)
            case .Failure(let error):
                print(error)
            }
        }
    }
    /**
    POST送信
    */
    func code_8_post() {
        Alamofire.request (.POST, "http://httpbin.org/post",
            parameters: ["type": 1, "name" : "Swift"])
        .responseString { response in
                print(response)
        }
    }
    /**
    ファイルをアップロードする例
    */
    func code_8_fileupload() {
        let url = "http://httpbin.org/post"
        let fileURL = NSBundle.mainBundle().URLForResource("Default",
            withExtension: "png")
        Alamofire.upload(.POST, url, file: fileURL!)
        .progress { (byteWritten, totalByteWritten, totalBytesExpectedToWrite) in
            print(totalBytesExpectedToWrite)
        }
        .responseString { response in
            print(response.result.value)
        }
    }
    func code_8_filedownload() {
        let url = "http://httpbin.org/stream/100"
        // （1）デフォルトダウンロードの指定
        let destination = Alamofire.Request.suggestedDownloadDestination(directory:
            .DocumentDirectory, domain: .UserDomainMask)
        Alamofire.download(.GET, url, destination: destination)
        .response { (request, response, _, error)  in
            // 処理
        }
    }
}

