//
//  Person.swift
//  8-3-5_HimotokiSample
//
//  Created by oga on 2015/09/20.
//  Copyright © 2015年 Ryuji Watanabe. All rights reserved.
//

import Foundation
import Himotoki

enum SexType: Int {
    case Male
    case Female
}
struct Person: Decodable {
    var name: String
    var height: Double?
    var birthday: NSDate?
    var sex: SexType
    var gameItem: [GameItem]
    
    static func decode(e: Extractor) -> Person? {
        return build(Person.init)(
            e <| "name",
            e <| "height",
            (e <| "birthday").flatMap { NSDate(string: $0) },
            (e <| "sex").flatMap { SexType(rawValue: $0) },
            e <|| "game"
        )
    }
}
