//: Playground - noun: a place where people can play

import UIKit

///////////////////////////////////
//
// 4-2 Optional型
//
///////////////////////////////////

// 4-2-1 Optional型とは

// 定義を見るにはOptionalをcmd + click
let optional:Optional<Int> = 1

let str1     = "100"
let number1  = Int(str1)
let str2     = "abc"
let number2  = Int(str2)

let i:Int?
// let i:Optional<Int> // と同義

// 4-2-2 nilの代入
let optionalStr:String? = nil
// let str:String = nil // コンパイルエラー

// 4-2-3 Optional型への代入
var optionalNumber:Int? = 100

var number = 200
optionalNumber = number

// 4-2-4 アンラップ
if optionalNumber != nil {
    number = optionalNumber!
    print("number is \(number)")
}

// 4-2-5 Optional Binding

var str = "100"
if let strNumber = Int(str) {
    print("number is \(strNumber)")
}

// 複数のOptional Binding
var priceStr1 = "1000"
var priceStr2 = "500"
if let price1 = Int(priceStr1), price2 = Int(priceStr2) {
    print("total price is \(price1 + price2)")
}

if let price1 = Int(priceStr1), price2 = Int(priceStr2)
    where price1 > price2 {
        print("price1 is expensive than price2")
}

// 4-2-6 Optionalパターンマッチ
if case let price? = Int(priceStr1) {
    print("price is \(price)")
}

// 4-2-7 ?? 演算子
str = "100"
number = Int(str) ?? 0

var s1 = "non number"
var s2 = "100"

number = Int(s1) ?? Int(s2) ?? 0


