// コード 8.64 Decorator パターンの実装

import UIKit

// ピザ、トッピングの元になるクラス
class Food {
    func name() -> String {
        return ""
    }
}
// トッピングクラス
class Topping: Food {
    private let food: Food
    init(_ newFood: Food) {
        food = newFood
    }
}
// ピザクラス
class Pizza: Food {
    override func name() -> String {
        return ""
    }
}
// 以下は実際のトッピング
class ShrimpTopping: Topping {
    override func name() -> String {
        return self.food.name() + " エビ"
    }
}
class CrabTopping: Topping {
    override func name() -> String {
        return self.food.name() + " カニ"
    }
}
class ConeTopping: Topping {
    override func name() -> String {
        return self.food.name() + " コーン"
    }
}
// シーフードピザのインスタンスを生成
let seafoodPizza = ShrimpTopping(CrabTopping(Pizza()))
// トッピングを表示
print(seafoodPizza.name()) // " カニエビ"
